<?php

namespace Modelos;
// require_once "conexion.php";
use Conect\Conexion;
use PDO;

class ModeloProductos
{

    public static function mdlMostrarProductos($tabla, $item, $valor)
    {

        if ($item != null) {

            $stmt = Conexion::conectar()->prepare("SELECT * FROM $tabla  WHERE $item = :$item ORDER BY id DESC");
            $stmt->bindParam(":" . $item, $valor, PDO::PARAM_STR);

            $stmt->execute();
            return $stmt->fetch();
        } else {
            $stmt = Conexion::conectar()->prepare("SELECT * FROM $tabla");
            //$stmt->bindParam(":".$item, $valor, PDO::PARAM_STR);    
            $stmt->execute();
            return $stmt->fetchall();
        }


        $stmt->close();
        $stmt = null;
    }
    public static function mdlMostrarProductosMasVendidos($tabla, $item, $valor, $orden)
    {

        if ($item != null) {

            $stmt = Conexion::conectar()->prepare("SELECT * FROM $tabla  WHERE $item = :$item ORDER BY id DESC");
            $stmt->bindParam(":" . $item, $valor, PDO::PARAM_STR);

            $stmt->execute();
            return $stmt->fetch();
        } else {
            $stmt = Conexion::conectar()->prepare("SELECT * FROM $tabla ORDER BY $orden DESC");
            //$stmt->bindParam(":".$item, $valor, PDO::PARAM_STR);    
            $stmt->execute();
            return $stmt->fetchall();
        }


        $stmt->close();
        $stmt = null;
    }
    public static function mdlMostrarProductosStock($tabla, $item, $valor)
    {


        $stmt = Conexion::conectar()->prepare("SELECT * FROM $tabla  WHERE $item = :$item ORDER BY id DESC");
        $stmt->bindParam(":" . $item, $valor, PDO::PARAM_STR);

        $stmt->execute();
        return $stmt->fetch();


        $stmt->close();
        $stmt = null;
    }

    // REGISTRO DE PRODUCTOS
    public static function mdlCrearProducto($tabla, $datos)
    {

        $stmt = Conexion::conectar()->prepare("INSERT INTO $tabla(id_categoria, codigo, serie, descripcion, imagen, stock, tipo_precio, valor_unitario,  precio_unitario, precio_compra, igv, codigoafectacion, codunidad) VALUES (:id_categoria, :codigo, :serie, :descripcion, :imagen, :stock, :tipo_precio, :valor_unitario,  :precio_unitario, :precio_compra, :igv,  :codigoafectacion, :codunidad)");

        $stmt->bindParam(":id_categoria", $datos['id_categoria'], PDO::PARAM_INT);
        $stmt->bindParam(":codigo", $datos['codigo'], PDO::PARAM_STR);
        $stmt->bindParam(":serie", $datos['serie'], PDO::PARAM_STR);
        $stmt->bindParam(":descripcion", $datos['descripcion'], PDO::PARAM_STR);
        $stmt->bindParam(":imagen", $datos['imagen'], PDO::PARAM_STR);
        $stmt->bindParam(":stock", $datos['stock'], PDO::PARAM_STR);
        $stmt->bindParam(":tipo_precio", $datos['tipo_precio'], PDO::PARAM_STR);
        $stmt->bindParam(":valor_unitario", $datos['valor_unitario'], PDO::PARAM_STR);
        $stmt->bindParam(":precio_unitario", $datos['precio_unitario'], PDO::PARAM_STR);
        $stmt->bindParam(":precio_compra", $datos['precio_compra'], PDO::PARAM_STR);
        $stmt->bindParam(":igv", $datos['igv'], PDO::PARAM_STR);
        $stmt->bindParam(":codigoafectacion", $datos['codigoafectacion'], PDO::PARAM_STR);
        $stmt->bindParam(":codunidad", $datos['unidad'], PDO::PARAM_STR);

        if ($stmt->execute()) {
            return   'ok';
        } else {
            return  'error';
        }

        $stmt->close();
        $stmt = null;
    }
    // EDITAR PRODUCTO
    public static function mdlEditarProducto($tabla, $datos)
    {

        $stmt = Conexion::conectar()->prepare("UPDATE $tabla set id = :id, id_categoria = :id_categoria, codigo=:codigo, serie = :serie, descripcion = :descripcion, imagen = :imagen, stock = :stock, precio_compra = :precio_compra,  precio_unitario =  :precio_unitario, valor_unitario = :valor_unitario, igv = :igv, codigoafectacion = :codigoafectacion, codunidad = :codunidad WHERE id = :id");

        $stmt->bindParam(":id", $datos['id'], PDO::PARAM_INT);
        $stmt->bindParam(":id_categoria", $datos['id_categoria'], PDO::PARAM_INT);
        $stmt->bindParam(":serie", $datos['serie'], PDO::PARAM_STR);
        $stmt->bindParam(":codigo", $datos['codigo'], PDO::PARAM_STR);
        $stmt->bindParam(":descripcion", $datos['descripcion'], PDO::PARAM_STR);
        $stmt->bindParam(":imagen", $datos['imagen'], PDO::PARAM_STR);
        $stmt->bindParam(":stock", $datos['stock'], PDO::PARAM_STR);
        $stmt->bindParam(":precio_compra", $datos['precio_compra'], PDO::PARAM_STR);
        $stmt->bindParam(":precio_unitario", $datos['precio_unitario'], PDO::PARAM_STR);
        $stmt->bindParam(":valor_unitario", $datos['valor_unitario'], PDO::PARAM_STR);
        $stmt->bindParam(":codigoafectacion", $datos['codigoafectacion'], PDO::PARAM_STR);
        $stmt->bindParam(":codunidad", $datos['unidad'], PDO::PARAM_STR);
        $stmt->bindParam(":igv", $datos['igv'], PDO::PARAM_STR);

        if ($stmt->execute()) {
            return   'ok';
        } else {
            return  'error';
        }

        $stmt->close();
        $stmt = null;
    }
    // EDITAR PRODUCTO
    public static function mdlActivaDesactivaUnidadMedida($tabla, $datos)
    {

        $stmt = Conexion::conectar()->prepare("UPDATE $tabla set activo = :activo WHERE id = :id");

        $stmt->bindParam(":id", $datos['id'], PDO::PARAM_INT);
        $stmt->bindParam(":activo", $datos['modo'], PDO::PARAM_STR);


        if ($stmt->execute()) {
            return   'ok';
        } else {
            return  'error';
        }

        $stmt->close();
        $stmt = null;
    }
    // EDITAR PRODUCTO
    public static function mdlActualizarStock($tabla, $detalle, $valor)
    {
        
        if ($valor == null) {
            $stmt = Conexion::conectar()->prepare("UPDATE $tabla set stock = :stock WHERE id = :id");

            foreach ($detalle as $k => $v) {
                
                $item = 'id';
                $valor = $v['id'];
                $productos = ModeloProductos::mdlMostrarProductosStock($tabla, $item, $valor);

                foreach ($productos as $i => $prod) {

                    $cantidad = $prod['stock'] - $v['cantidad'];

                    $stmt->bindParam(":id", $v['id'], PDO::PARAM_INT);
                    $stmt->bindParam(":stock", $cantidad, PDO::PARAM_STR);


                    $stmt->execute();
                }
            }
        } else {

            $stmt = Conexion::conectar()->prepare("UPDATE $tabla set stock = :stock WHERE id = :id");

            foreach ($detalle as $k => $v) {
                
                $item = 'id';
                $valor = $v['id'];
                $productos = ModeloProductos::mdlMostrarProductosStock($tabla, $item, $valor);

                foreach ($productos as $i => $prod) {

                    $cantidad = $prod['stock'] + $v['cantidad'];

                    $stmt->bindParam(":id", $v['id'], PDO::PARAM_INT);
                    $stmt->bindParam(":stock", $cantidad, PDO::PARAM_STR);


                    $stmt->execute();
                }
            }
        }
    }
    public static function mdlActualizarStockPorAjuste($datos)
    {

 $tabla = 'productos';
$stmt = Conexion::conectar()->prepare("UPDATE $tabla set stock = :stock WHERE id = :id");

       
        $item = 'id';
        $valor = $datos['idproducto'];
        $producto = ModeloProductos::mdlMostrarProductosStock($tabla, $item, $valor);

        if ($datos['accion'] == 'salida') {
            $cantidad = $producto['stock'] - $datos['cantidad'];
        } else {
            $cantidad = $producto['stock'] + $datos['cantidad'];
        }


        $stmt->bindParam(":id", $datos['idproducto'], PDO::PARAM_INT);
        $stmt->bindParam(":stock", $cantidad, PDO::PARAM_STR);


        $stmt->execute();
    }
    // EDITAR PRODUCTO MAS VENDIDO
    public static function mdlActualizarMasVendido($tabla, $detalle, $valor)
    {

        if ($valor == null) {
            $stmt = Conexion::conectar()->prepare("UPDATE $tabla set ventas = :ventas WHERE id = :id");

            foreach ($detalle as $k => $v) {
                $tabla = 'productos';
                $item = 'id';
                $valor = $v['id'];
                $productos = ModeloProductos::mdlMostrarProductosStock($tabla, $item, $valor);

                foreach ($productos as $i => $prod) {

                    $cantidad = $prod['ventas'] - $v['cantidad'];

                    $stmt->bindParam(":id", $v['id'], PDO::PARAM_INT);
                    $stmt->bindParam(":ventas", $cantidad, PDO::PARAM_STR);


                    $stmt->execute();
                }
            }
        } else {

            $stmt = Conexion::conectar()->prepare("UPDATE $tabla set ventas = :ventas WHERE id = :id");

            foreach ($detalle as $k => $v) {
                $tabla = 'productos';
                $item = 'id';
                $valor = $v['id'];
                $productos = ModeloProductos::mdlMostrarProductosStock($tabla, $item, $valor);

                foreach ($productos as $i => $prod) {

                    $cantidad = $prod['ventas'] + $v['cantidad'];

                    $stmt->bindParam(":id", $v['id'], PDO::PARAM_INT);
                    $stmt->bindParam(":ventas", $cantidad, PDO::PARAM_STR);


                    $stmt->execute();
                }
            }
        }
    }

    // ELIMINAR PRODUCTO
    public static function mdlEliminarProducto($tabla, $datos)
    {

        $stmt = Conexion::conectar()->prepare("DELETE FROM $tabla  WHERE id=:id");
        $stmt->bindParam(":id", $datos, PDO::PARAM_INT);

        if ($stmt->execute()) {
            return 'ok';
        } else {
            return 'error';
        }
        $stmt->close();
        $stmt = null;
    }



    // LISTAR PRODUCTOS OTRO MÉTODO
    public static function mdlListarProductos()
    {

        $content =  "<tbody class='body-productos'></tbody>";
        return $content;
    }
    // LISTAR PRODUCTOS PARA LAS VENTAS
    public static function mdlListarProductosVentas()
    {

        $content =  "<tbody class='body-productos-ventas'></tbody>";
        return $content;
    }
    // LISTAR PRODUCTOS PARA LAS VENTAS
    public static function mdlListarProductosGuia()
    {

        $content =  "<tbody class='body-productos-guia'></tbody>";
        return $content;
    }
}





















<?php

namespace Controladores;

use Modelos\ModeloProductos;

class ControladorProductos
{
    // MOSTRAR ProductoS|
    public static function ctrMostrarProductos($item, $valor)
    {

        $tabla = 'productos';
        $respuesta = ModeloProductos::mdlMostrarProductos($tabla, $item, $valor);
        return $respuesta;
    }
    // MOSTRAR ProductoS|
    public static function ctrMostrarProductosMasVendidos($item, $valor, $orden)
    {

        $tabla = 'productos';
        $respuesta = ModeloProductos::mdlMostrarProductosMasVendidos($tabla, $item, $valor, $orden);
        return $respuesta;
    }
    // LISTAR UNIDADES DE MEDIDA
    public static function ctrMostrarUnidade($item, $valor)
    {

        $tabla = 'unidad';
        $respuesta = ModeloProductos::mdlMostrarProductos($tabla, $item, $valor);
        return $respuesta;
    }
    public static function ctrMostrarCategorias($item, $valor)
    {

        $tabla = 'categorias';
        $respuesta = ModeloProductos::mdlMostrarProductos($tabla, $item, $valor);
        return $respuesta;
    }
    // CREAR PRODUCTO
    public static function ctrCrearProducto($productos, $file)
    {

        if (isset($productos['nuevaDescripcion'])) {

            if (
                preg_match('/^[0-9.]+$/', $productos['nuevoPrecioCompra']) &&
                preg_match('/^[0-9.]+$/', $productos['nuevoPrecioUnitario'])
            ) {

                //  VALIDAR IMAGEN   
                $rutabd = "vistas/img/productos/default/anonymous.png";
                if (isset($file["nuevaImagen"]["tmp_name"]) && !empty($file["nuevaImagen"]["tmp_name"])) {

                    list($ancho, $alto) = getimagesize($file["nuevaImagen"]["tmp_name"]);
                    $nuevoAncho = 500;
                    $nuevoAlto = 500;

                    //CARPETA DONDE SE GUARDARÁ LA IMAGEN
                    $directorio = dirname(__FILE__) . "/../vistas/img/productos/" . $productos['nuevoCodigo'];
                    // mkdir($directorio, 0755);
                    if (!file_exists($directorio)) {
                        mkdir($directorio, 0755, true);
                    }

                    if ($file["nuevaImagen"]["type"] == "image/jpeg") {

                        $aleatorio = mt_rand(100, 999);
                        $ruta = dirname(__FILE__) . "/../vistas/img/productos/" . $productos['nuevoCodigo'] . "/" . $aleatorio . ".jpeg";
                        $rutabd = "vistas/img/productos/" . $productos['nuevoCodigo'] . "/" . $aleatorio . ".jpeg";

                        $origen = imagecreatefromjpeg($file["nuevaImagen"]["tmp_name"]);
                        $destino = imagecreatetruecolor($nuevoAncho, $nuevoAlto);
                        imagecopyresized($destino, $origen, 0, 0, 0, 0, $nuevoAncho, $nuevoAlto, $ancho, $alto);
                        imagejpeg($destino, $ruta);
                    }
                    if ($file["nuevaImagen"]["type"] == "image/png") {

                        $aleatorio = mt_rand(100, 999);
                        $ruta = dirname(__FILE__) . "/../vistas/img/productos/" . $productos['nuevoCodigo'] . "/" . $aleatorio . ".png";
                        $rutabd = "vistas/img/productos/" . $productos['nuevoCodigo'] . "/" . $aleatorio . ".png";

                        $origen = imagecreatefrompng($file["nuevaImagen"]["tmp_name"]);
                        $destino = imagecreatetruecolor($nuevoAncho, $nuevoAlto);
                        imagecopyresized($destino, $origen, 0, 0, 0, 0, $nuevoAncho, $nuevoAlto, $ancho, $alto);
                        imagepng($destino, $ruta);
                    }
                }

                //$ruta = "vistas/img/productos/default/anonymous.png";
                $tabla = "productos";
                $datos = array(
                    "id_categoria" => $productos['nuevaCategoria'],
                    "codigo" => $productos['nuevoCodigo'],
                    "serie" => $productos['nuevaSerie'],
                    "codigoafectacion" => $productos['tipo_afectacion'],
                    "unidad" => $productos['unidad'],
                    "descripcion" => $productos['nuevaDescripcion'],
                    "stock" => $productos['nuevoStock'],
                    "tipo_precio" => '01',
                    "valor_unitario" => $productos['nuevoValorUnitario'],
                    "precio_unitario" => $productos['nuevoPrecioUnitario'],
                    "precio_compra" => $productos['nuevoPrecioCompra'],
                    "igv" => $productos['nuevoigv'],
                    "imagen" => $rutabd
                );

                $respuesta = ModeloProductos::mdlCrearProducto($tabla, $datos);

                return $respuesta;
            } else {
                echo "<script>
                        Swal.fire({
                            title: '¡El producto no puede ir vacío o llevar caracteres especiales!',
                            text: '...',
                            icon: 'error',
                            showCancelButton: false,
                            confirmButtonColor: '#3085d6',
                            cancelButtonColor: '#d33',
                            confirmButtonText: 'Cerrar'
                        }).then((result) => {
                            if (result.isConfirmed) {
                            window.location = 'productos';
                            }
                        })</script>";
            }
        }
    }
    // EDITAR PRODUCTO
    public  function ctrEditarProducto()
    {

        if (isset($_POST['editarDescripcion'])) {


            //  VALIDAR IMAGEN   
            $ruta = $_POST['imagenActual'];
            if (isset($_FILES["editarImagen"]["tmp_name"]) && !empty($_FILES["editarImagen"]["tmp_name"])) {

                list($ancho, $alto) = getimagesize($_FILES["editarImagen"]["tmp_name"]);
                $nuevoAncho = 500;
                $nuevoAlto = 500;

                //CARPETA DONDE SE GUARDARÁ LA IMAGEN
                $directorio = "vistas/img/productos/" . $_POST['editarCodigo'];
                if (empty($_POST['imagenActual']) && $_POST['imagenActual'] != "vistas/img/productos/default/anonymous.png") {

                    unlink($_POST['imagenActual']);
                } else {
                    if (!file_exists($directorio)) {
                        mkdir($directorio, 0755);
                    }
                }

                if ($_FILES["editarImagen"]["type"] == "image/jpeg") {

                    $aleatorio = mt_rand(100, 999);
                    $ruta = "vistas/img/productos/" . $_POST['editarCodigo'] . "/" . $aleatorio . ".jpeg";

                    $origen = imagecreatefromjpeg($_FILES["editarImagen"]["tmp_name"]);
                    $destino = imagecreatetruecolor($nuevoAncho, $nuevoAlto);
                    imagecopyresized($destino, $origen, 0, 0, 0, 0, $nuevoAncho, $nuevoAlto, $ancho, $alto);
                    imagejpeg($destino, $ruta);
                }
                if ($_FILES["editarImagen"]["type"] == "image/png") {

                    $aleatorio = mt_rand(100, 999);
                    $ruta = "vistas/img/productos/" . $_POST['editarCodigo'] . "/" . $aleatorio . ".png";

                    $origen = imagecreatefrompng($_FILES["editarImagen"]["tmp_name"]);
                    $destino = imagecreatetruecolor($nuevoAncho, $nuevoAlto);
                    imagecopyresized($destino, $origen, 0, 0, 0, 0, $nuevoAncho, $nuevoAlto, $ancho, $alto);
                    imagepng($destino, $ruta);
                }
            }

            //$ruta = "vistas/img/productos/default/anonymous.png";
            $tabla = "productos";
            $datos = array(
                "id" => $_POST['editarid'],
                "id_categoria" => $_POST['editarCategoria'],
                "codigo" => $_POST['editarCodigo'],
                "serie" => $_POST['editarSerie'],
                "codigoafectacion" => $_POST['editarAfectacion'],
                "unidad" => $_POST['editarUnidadMedida'],
                "descripcion" => $_POST['editarDescripcion'],
                "stock" => $_POST['editarStock'],
                "valor_unitario" => $_POST['editarValorUnitario'],
                "precio_unitario" => $_POST['editarPrecioUnitario'],
                "precio_compra" => $_POST['editarPrecioCompra'],
                "igv" => $_POST['editarigv'],
                "imagen" => $ruta
            );

            $respuesta = ModeloProductos::mdlEditarProducto($tabla, $datos);

            if ($respuesta == 'ok') {
                echo "<script>
                            Swal.fire({
                                title: '¡El producto ha sido actualizado corréctamente!',
                                text: '...',
                                icon: 'success',
                                showCancelButton: false,
                                confirmButtonColor: '#3085d6',
                                cancelButtonColor: '#d33',
                                confirmButtonText: 'Cerrar'
                            })
                            if(window.history.replaceState){
                                window.history.replaceState(null,null, window.location.href);
                                }
                            </script>";
            }
        }
    }

    // ELIMINAR PRODUCTO 
    public static function ctrEliminarProducto()
    {

        if (isset($_GET['idProducto'])) {
            $tabla = "productos";
            $datos = $_GET['idProducto'];
            if (isset($_GET['imagen']) && $_GET['imagen'] != "vistas/img/productos/default/anonymous.png") {

                unlink($_GET['imagen']);
                rmdir("vistas/img/productos/" . $_GET['codigo']);
            }

            $respuesta = ModeloProductos::mdlEliminarProducto($tabla, $datos);
            if ($respuesta == 'ok') {

                echo "<script>
           Swal.fire({
            title: '¡El producto ha sido eliminado corréctamente!',
            text: '...',
            icon: 'success',
            showCancelButton: false,
            confirmButtonColor: '#3085d6',
            cancelButtonColor: '#d33',
            confirmButtonText: 'Cerrar'
        }).then((result) => {
            if(result.isConfirmed){
                
              window.location = 'productos';
        }
    })     
           </script>";
            } else {
                echo "error";
            }
        }
    }
    // FIN ELIMINAR PRODUCTO:

    public  function ctrListarProductos()
    {

        $respuesta = ModeloProductos::mdlListarProductos();
        echo $respuesta;
    }
    public  function ctrListarProductosVentas()
    {

        $respuesta = ModeloProductos::mdlListarProductosVentas();
        echo $respuesta;
    }
    public  function ctrListarProductosGuia()
    {

        $respuesta = ModeloProductos::mdlListarProductosGuia();
        echo $respuesta;
    }
    // ACTIVAR Y DESACTIVAR  UNIDAD DE MEDIDA
    public static function ctrActivaDesactivaUnidadMedida($datos)
    {
        $tabla = "unidad";
        $respuesta = ModeloProductos::mdlActivaDesactivaUnidadMedida($tabla, $datos);
        echo $respuesta;
    }

    public static function ctrActualizarStock($detalle, $valor)
    {
        $tabla = "productos";
        $respuesta = ModeloProductos::mdlActualizarStock($tabla, $detalle, $valor);
        return $respuesta;
    }

    public static function ctrActualizarStockPorAjuste($datos)
    {
        $respuesta = ModeloProductos::mdlActualizarStockPorAjuste($datos);
        return $respuesta;
    }

    public static function ctrActualizarMasVendidos($detalle, $valor)
    {
        $tabla = "productos";
        $respuesta = ModeloProductos::mdlActualizarMasVendido($tabla, $detalle, $valor);
        return $respuesta;
    }

    public static function ctrMostrarProductosStock($item, $valor)
    {

        $tabla = 'productos';
        $respuesta = ModeloProductos::mdlMostrarProductosStock($tabla, $item, $valor);
        return $respuesta;
    }
}
