<?php

namespace api;

class GeneradorXML
{

   // const URL_API_FABO = 'http://localhost/apiTechMultiServ/apifactura';
   const URL_API_FABO = 'https://apitech.apifacturacion.com/v2/apifactura';
   const URL_API_NOTA_CREDITO =  'https://apitech.apifacturacion.com/v2/apinotac';
   const URL_API_NOTA_DEBITO =  'https://apitech.apifacturacion.com/v2/apinotad';
   const URL_API_RESUMEN =  'https://apitech.apifacturacion.com/v2/apiresumen';
   const URL_API_BAJA =  'https://apitech.apifacturacion.com/v2/apibaja';
   const URL_API_GUIA_RR =  'https://apitech.apifacturacion.com/v2/apiguia';

   function CrearXMLFactura($nombrexml, $emisor, $cliente, $comprobante, $detalle, $sucursal)
   {
      $archivo = '';
      $doc = new \DOMDocument(); //clase que permite crear documento archivos, xml
      $doc->formatOutput = FALSE;
      $doc->preserveWhiteSpace = TRUE;
      $doc->encoding = 'utf-8';
      header("Access-Control-Allow-Origin: *");
      $licenciaFile = '../LICENCIA';
      if(file_exists($licenciaFile)){
         $archivo = file($licenciaFile);
      }else{
         echo "NO ELIMINAR NI MODIFICAR EL ARCHIVO DE LICENCIA";
         exit();
      }  
 
      $licencia = $archivo;
      $datos = array(
         "emisor" => $emisor,
         "sucursal" => $sucursal,
         "cliente" => $cliente,
         'detalle' => $detalle,
         "comprobante" => $comprobante,
         "licencia" => $licencia
      );

      //  var_dump($datos);
      //  exit();
      $curl = curl_init();
      curl_setopt_array($curl, array(
         CURLOPT_URL => self::URL_API_FABO,
         CURLOPT_RETURNTRANSFER => true,
         CURLOPT_ENCODING => '',
         CURLOPT_MAXREDIRS => 10,
         CURLOPT_TIMEOUT => 0,
         CURLOPT_FOLLOWLOCATION => true,
         CURLOPT_POST => true,
         CURLOPT_POSTFIELDS  => http_build_query($datos),
         CURLOPT_HTTPAUTH => CURLAUTH_BASIC,
         CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
         CURLOPT_CUSTOMREQUEST => 'POST',
         // CURLOPT_CAINFO => dirname(__FILE__) . "/../api/cacert.pem" //Comentar si sube a un hosting 
         //para ejecutar los procesos de forma local en windows
         //enlace de descarga del cacert.pem https://curl.haxx.se/docs/caextract.html
      ));

      $response = curl_exec($curl);
      $httpcode = curl_getinfo($curl, CURLINFO_HTTP_CODE);
      curl_close($curl);

      $xml = json_decode($response, true);
      //  var_dump($response);
      if (!empty($xml)) { //200: La comunicacion fue satisfactoria {
         if (strlen($xml) > 70) {
            $doc->loadXML($xml); //crear el xml en base a un texto
            $doc->save($nombrexml . '.XML'); //guarda el xml generado
         } else {
            echo $xml;
            exit();
         }
      } else {
         echo "PROBLEMAS DE CONEXIÓN";
         exit();
      }
   }

   function CrearXMLNotaCredito($nombrexml, $emisor, $cliente, $comprobante, $detalle, $sucursal)
   {


      $doc = new \DOMDocument(); //clase que permite crear documento archivos, xml
      $doc->formatOutput = FALSE;
      $doc->preserveWhiteSpace = TRUE;
      $doc->encoding = 'utf-8';
      header("Access-Control-Allow-Origin: *");


      $datos = array(
         "emisor" => $emisor,
         "sucursal" => $sucursal,
         "cliente" => $cliente,
         'detalle' => $detalle,
         "comprobante" => $comprobante,

      );
      // var_dump($detalles);
      $curl = curl_init();
      curl_setopt_array($curl, array(
         CURLOPT_URL => self::URL_API_NOTA_CREDITO,
         CURLOPT_RETURNTRANSFER => true,
         CURLOPT_ENCODING => '',
         CURLOPT_MAXREDIRS => 10,
         CURLOPT_TIMEOUT => 0,
         CURLOPT_FOLLOWLOCATION => true,
         CURLOPT_POST => true,
         CURLOPT_POSTFIELDS  => http_build_query($datos),
         CURLOPT_HTTPAUTH => CURLAUTH_BASIC,
         CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
         CURLOPT_CUSTOMREQUEST => 'POST',
         // CURLOPT_CAINFO => dirname(__FILE__) . "/../api/cacert.pem" //Comentar si sube a un hosting 
         //para ejecutar los procesos de forma local en windows
         //enlace de descarga del cacert.pem https://curl.haxx.se/docs/caextract.html
      ));

      $response = curl_exec($curl);
      $httpcode = curl_getinfo($curl, CURLINFO_HTTP_CODE);
      curl_close($curl);

      $xml = json_decode($response, true);
      // var_dump($response);
      if (!empty($xml)) { //200: La comunicacion fue satisfactoria {
         if (strlen($xml) > 70) {
            $doc->loadXML($xml); //crear el xml en base a un texto
            $doc->save($nombrexml . '.XML'); //guarda el xml generado
         } else {
            echo $xml;
            exit();
         }
      } else {
         echo "PROBLEMAS DE CONEXIÓN";
         exit();
      }
   }

   function CrearXMLNotaDebito($nombrexml, $emisor, $cliente, $comprobante, $detalle, $sucursal)
   {

      $doc = new \DOMDocument(); //clase que permite crear documento archivos, xml
      $doc->formatOutput = FALSE;
      $doc->preserveWhiteSpace = TRUE;
      $doc->encoding = 'utf-8';
      header("Access-Control-Allow-Origin: *");


      $datos = array(
         "emisor" => $emisor,
         "sucursal" => $sucursal,
         "cliente" => $cliente,
         'detalle' => $detalle,
         "comprobante" => $comprobante,

      );
      // var_dump($detalles);
      $curl = curl_init();
      curl_setopt_array($curl, array(
         CURLOPT_URL => self::URL_API_NOTA_DEBITO,
         CURLOPT_RETURNTRANSFER => true,
         CURLOPT_ENCODING => '',
         CURLOPT_MAXREDIRS => 10,
         CURLOPT_TIMEOUT => 0,
         CURLOPT_FOLLOWLOCATION => true,
         CURLOPT_POST => true,
         CURLOPT_POSTFIELDS  => http_build_query($datos),
         CURLOPT_HTTPAUTH => CURLAUTH_BASIC,
         CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
         CURLOPT_CUSTOMREQUEST => 'POST',
         // CURLOPT_CAINFO => dirname(__FILE__) . "/../api/cacert.pem" //Comentar si sube a un hosting 
         //para ejecutar los procesos de forma local en windows
         //enlace de descarga del cacert.pem https://curl.haxx.se/docs/caextract.html
      ));

      $response = curl_exec($curl);
      $httpcode = curl_getinfo($curl, CURLINFO_HTTP_CODE);
      curl_close($curl);

      $xml = json_decode($response, true);
      // var_dump($response);
      if (!empty($xml)) { //200: La comunicacion fue satisfactoria {
         if (strlen($xml) > 70) {
            $doc->loadXML($xml); //crear el xml en base a un texto
            $doc->save($nombrexml . '.XML'); //guarda el xml generado
         } else {
            echo $xml;
            exit();
         }
      } else {
         echo "PROBLEMAS DE CONEXIÓN";
         exit();
      }
   }

   function CrearXMLResumenDocumentos($emisor, $cabecera, $detalle, $nombrexml)
   {
      // var_dump($emisor);

      $doc = new \DOMDocument(); //clase que permite crear documento archivos, xml
      $doc->formatOutput = FALSE;
      $doc->preserveWhiteSpace = TRUE;
      $doc->encoding = 'utf-8';
      header("Access-Control-Allow-Origin: *");


      $datos = array(
         "emisor" => $emisor,
         'detalle' => $detalle,
         "cabecera" => $cabecera,

      );
      // var_dump($detalles);
      $curl = curl_init();
      curl_setopt_array($curl, array(
         CURLOPT_URL => self::URL_API_RESUMEN,
         CURLOPT_RETURNTRANSFER => true,
         CURLOPT_ENCODING => '',
         CURLOPT_MAXREDIRS => 10,
         CURLOPT_TIMEOUT => 0,
         CURLOPT_FOLLOWLOCATION => true,
         CURLOPT_POST => true,
         CURLOPT_POSTFIELDS  => http_build_query($datos),
         CURLOPT_HTTPAUTH => CURLAUTH_BASIC,
         CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
         CURLOPT_CUSTOMREQUEST => 'POST',
         // CURLOPT_CAINFO => dirname(__FILE__) . "/../api/cacert.pem" //Comentar si sube a un hosting 
         //para ejecutar los procesos de forma local en windows
         //enlace de descarga del cacert.pem https://curl.haxx.se/docs/caextract.html
      ));

      $response = curl_exec($curl);
      $httpcode = curl_getinfo($curl, CURLINFO_HTTP_CODE);
      curl_close($curl);

      $xml = json_decode($response, true);
      //  var_dump($response);
      if (!empty($xml)) { //200: La comunicacion fue satisfactoria {
         if (strlen($xml) > 70) {
            $doc->loadXML($xml); //crear el xml en base a un texto
            $doc->save($nombrexml . '.XML'); //guarda el xml generado
         } else {
            echo $xml;
            exit();
         }
      } else {
         echo "PROBLEMAS DE CONEXIÓN";
         exit();
      }
   }

   function CrearXmlBajaDocumentos($emisor, $cabecera, $detalle, $nombrexml)
   {


      $doc = new \DOMDocument(); //clase que permite crear documento archivos, xml
      $doc->formatOutput = FALSE;
      $doc->preserveWhiteSpace = TRUE;
      $doc->encoding = 'utf-8';
      header("Access-Control-Allow-Origin: *");


      $datos = array(
         "emisor" => $emisor,
         'detalle' => $detalle,
         "cabecera" => $cabecera,

      );
      // var_dump($detalles);
      $curl = curl_init();
      curl_setopt_array($curl, array(
         CURLOPT_URL => self::URL_API_BAJA,
         CURLOPT_RETURNTRANSFER => true,
         CURLOPT_ENCODING => '',
         CURLOPT_MAXREDIRS => 10,
         CURLOPT_TIMEOUT => 0,
         CURLOPT_FOLLOWLOCATION => true,
         CURLOPT_POST => true,
         CURLOPT_POSTFIELDS  => http_build_query($datos),
         CURLOPT_HTTPAUTH => CURLAUTH_BASIC,
         CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
         CURLOPT_CUSTOMREQUEST => 'POST',
         // CURLOPT_CAINFO => dirname(__FILE__) . "/../api/cacert.pem" //Comentar si sube a un hosting 
         //para ejecutar los procesos de forma local en windows
         //enlace de descarga del cacert.pem https://curl.haxx.se/docs/caextract.html
      ));

      $response = curl_exec($curl);
      $httpcode = curl_getinfo($curl, CURLINFO_HTTP_CODE);
      curl_close($curl);

      $xml = json_decode($response, true);
      // var_dump($response);
      if (!empty($xml)) { //200: La comunicacion fue satisfactoria {
         if (strlen($xml) > 70) {
            $doc->loadXML($xml); //crear el xml en base a un texto
            $doc->save($nombrexml . '.XML'); //guarda el xml generado
         } else {
            echo $xml;
            exit();
         }
      } else {
         echo "PROBLEMAS DE CONEXIÓN";
         exit();
      }
   }



   function CrearXMLGuiaRemision($nombrexml, $emisor, $datosGuia, $detalle)
   {
      $doc = new \DOMDocument(); //clase que permite crear documento archivos, xml
      $doc->formatOutput = FALSE;
      $doc->preserveWhiteSpace = TRUE;
      $doc->encoding = 'utf-8';
      header("Access-Control-Allow-Origin: *");


      $datos = array(
         'emisor' => $emisor,
         "datosGuia" => $datosGuia,
         'detalle' => $detalle,

      );
      // var_dump($detalles);
      $curl = curl_init();
      curl_setopt_array($curl, array(
         CURLOPT_URL => self::URL_API_GUIA_RR,
         CURLOPT_RETURNTRANSFER => true,
         CURLOPT_ENCODING => '',
         CURLOPT_MAXREDIRS => 10,
         CURLOPT_TIMEOUT => 0,
         CURLOPT_FOLLOWLOCATION => true,
         CURLOPT_POST => true,
         CURLOPT_POSTFIELDS  => http_build_query($datos),
         CURLOPT_HTTPAUTH => CURLAUTH_BASIC,
         CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
         CURLOPT_CUSTOMREQUEST => 'POST',
         // CURLOPT_CAINFO => dirname(__FILE__) . "/../api/cacert.pem" //Comentar si sube a un hosting 
         //para ejecutar los procesos de forma local en windows
         //enlace de descarga del cacert.pem https://curl.haxx.se/docs/caextract.html
      ));

      $response = curl_exec($curl);
      $httpcode = curl_getinfo($curl, CURLINFO_HTTP_CODE);
      curl_close($curl);

      $xml = json_decode($response, true);
      //   var_dump($response);
      if (!empty($xml)) { //200: La comunicacion fue satisfactoria {
         if (strlen($xml) > 70) {
            $doc->loadXML($xml); //crear el xml en base a un texto
            $doc->save($nombrexml . '.XML'); //guarda el xml generado
         } else {
            echo $xml;
            exit();
         }
      } else {
         echo "PROBLEMAS DE CONEXIÓN";
         exit();
      }
   }
}
